'-----------------------------------------------------
'Ansteuereungsbeispiel fr SR-LCD-Interface-Platine
'und Onboard SR-LCD-Interface des Adv.CC1-Appl.Boards
'CCTools 2002 cctools.hs-control.de (10.08.2002)
'-----------------------------------------------------
define ds port[10]
define shclk port[9]
define stclk port[12]

define cmd byte[3]
define i byte[2]

define SRPorts byte[24]
define RS Bit[185]
define LCDLight Bit[187]
define SRPort1 Bit[188]
define SRPort2 Bit[189]
define SRPort3 Bit[190]
define SRPort4 Bit[191]
define SRPort5 Bit[192]

define LCD_RS_0 &B10 : define LCD_RS_1 &B11 :define LCD_nowrite &B0
define prnLCD &h14f

define pop DA[1] 'Trick zum auslesen des Stacks(siehe ccintern.dharlos.de)
define PCFread &h16b
define PCFwrite &h15e
define PCF 64

define wert byte[1]' Byte zum Zwischenspeichern der
define P0 Bit[1]   ' Portzustnde. Es kann jedes
define P1 Bit[2]   ' beliebige Byte vom RAM gewhlt
define P2 Bit[3]   ' werden.
define P3 Bit[4]
define P4 Bit[5]
define P5 Bit[6]
define P6 Bit[7]
define P7 Bit[8]

'ASCII
Define A_ &H41 : Define B_ &H42 : Define C_ &H43 : Define D_ &H44 : Define E_ &H45
Define F_ &H46 : Define G_ &H47 : Define H_ &H48 : Define I_ &H49 : Define J_ &H4A
Define K_ &H4B : Define L_ &H4C : Define M_ &H4D : Define N_ &H4E : Define O_ &H4F
Define P_ &H50 : Define Q_ &H51 : Define R_ &H52 : Define S_ &H53 : Define T_ &H54
Define U_ &H55 : Define V_ &H56 : Define W_ &H57 : Define X_ &H58 : Define Y_ &H59 : Define Z_ &H5A
Define ak &H61 : Define bk &H62 : Define ck &H63 : Define dk &H64 : Define ek &H65
Define fk &H66 : Define gk &H67 : Define hk &H68 : Define ik &H69 : Define jk &H6A
Define kk &H6B : Define lk &H6C : Define mk &H6D : Define nk &H6E : Define ok &H6F
Define pk &H70 : Define qk &H71 : Define rk &H72 : Define sk &H73 : Define tk &H74
Define uk &H75 : Define vk &H76 : Define wk &H77 : Define xk &H78 : Define yk &H79 : Define zk &H7A
Define SPACE &H20 : Define MINUS &H2D : Define GLEICH &H3D : Define DPP &H3A
Define Dot &H2E
Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H94 : Define Line4 &HD4 'Fr 4x20 LCD
'Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H90 : Define Line4 &HD0 'Fr 4x16 LCD

gosub LCD_Init
SRPorts=0
LCDLight=ON : gosub setSRPorts
#loop
gosub LCD_CLS

cmd=hour : gosub LCD_Zahl2
cmd=DPP : gosub LCD_Char
cmd=minute : gosub LCD_Zahl2
cmd=DPP : gosub LCD_Char
cmd=second : gosub LCD_Zahl2

cmd=Line3 : gosub LCD_CMD
cmd=day : gosub LCD_Zahl2
cmd=Dot : gosub LCD_Char
cmd=month : gosub LCD_Zahl2
sys prnLCD,LCD_RS_1 or SRPorts : print ".20";
cmd=year : gosub LCD_Zahl2null

cmd=Line4 : gosub LCD_CMD
sys prnLCD,LCD_RS_1 or SRPorts : print "CCTools (c)2002";


pause 45
gosub LCD_CLS
cmd=hour : gosub LCD_Zahl2
cmd=DPP : gosub LCD_Char
cmd=minute : gosub LCD_Zahl2
cmd=DPP : gosub LCD_Char
cmd=second : gosub LCD_Zahl2

cmd=Line2 : gosub LCD_CMD
cmd=day : gosub LCD_Zahl2
cmd=Dot : gosub LCD_Char
cmd=month : gosub LCD_Zahl2
sys prnLCD,LCD_RS_1 or SRPorts : print ".20";
cmd=year : gosub LCD_Zahl2null

cmd=Line3 : gosub LCD_CMD
sys prnLCD,LCD_RS_1 or SRPorts : print "Hello World";

cmd=Line4 : gosub LCD_CMD
sys prnLCD,LCD_RS_1 or SRPorts : print "SR-LCD";

pause 45
goto loop


'----PCF8574-Aufrufe-------------------------
'Byte zum PCF8574 senden:
sys PCFwrite,wert,PCF

'Byte vom PCF8574 lesen:
sys PCFread,PCF+1 'Leseadresse=65
wert=pop

'Einzelport am PCF8574 setzen:
sys PCFread,PCF+1
wert=pop
P2 = off 'z.B P2 am PCF8574 auf Low setzen
sys PCFwrite,wert,PCF

'Einzelport am PCF8574 umschalten(toggle):
sys PCFread,PCF+1
wert=pop
P0 = not P0 'z.B P0 am PCF8574 togglen
sys PCFwrite,wert,PCF



'----LCD-Funktionen--------------------------
#LCD_Zahl3 ' 3 stellige Zahl ausgeben
if cmd > 99 then sys &h101,(cmd/100)+&h30,LCD_RS_1 or SRPorts else sys &h101,&h20,LCD_RS_1 or SRPorts
#LCD_Zahl2 ' 2 stellige Zahl ausgeben
if cmd > 9 then sys &h101,((cmd/10) mod 10)+&h30,LCD_RS_1 or SRPorts else sys &h101,&h20,LCD_RS_1 or SRPorts
#LCD_Zahl1 ' 1 stellige Zahl ausgeben
sys &h101,(cmd mod 10)+&h30,LCD_RS_1 or SRPorts
return
#LCD_Zahl3null ' 3 stellige Zahl ausgeben mit fhrender Nullen z.B.: 025 od. 005
sys &h101,(cmd/100)+&h30,LCD_RS_1 or SRPorts
#LCD_Zahl2null ' 2 stellige Zahl ausgeben mit fhrender Null z.B.: 05
sys &h101,((cmd/10) mod 10)+&h30,LCD_RS_1 or SRPorts
goto LCD_Zahl1

#LCD_CMD
sys &h101,cmd,LCD_RS_0 or SRPorts
return
#LCD_Char
sys &h101,cmd,LCD_RS_1 or SRPorts
return
#LCD_CLS
sys &h101,&b00000001,LCD_RS_0 or SRPorts
return
#LCD_Init
ds=off
shclk=off
stclk=off
sys &h12e
sys &h101,&b00111000,LCD_RS_0
sys &h101,&b00001111,LCD_RS_0
sys &h101,&b00000001,LCD_RS_0
sys &h101,&b00001110,LCD_RS_0
return
#setSRports 'Portzustnde an SR-LCD aktualisieren
sys &h12e,SRPorts
return
'//syscode "srlcd_pcf.s19" 'nur einmal laden, dann auskommentieren !

